education/about/urls.py
from django.urls import path
import about.views as about_views

app_name = 'about'

urlpatterns = [
    path('about/', about_views.about, name="about"),
    path('about/thanks/', about_views.thanks, name="thanks"),
]

education/course/urls.py
from django.urls import path
import course.views as course_views

app_name = 'course'

urlpatterns = [
    path('', course_views.index, name="index"),
    path('course/', course_views.CourseListView.as_view(), name="course_list"),
    path('course/<int:pk>/', course_views.CourseDetailView.as_view(), name="course_detail"),
    path('course/<int:pk>/update', course_views.CourseUpdateView.as_view(), name="course_update"),
    path('course/<int:pk>/delete', course_views.CourseDeleteView.as_view(), name="course_delete"),
    path('course/create/', course_views.CourseCreateView.as_view(), name="course_create"),
    path('category/', course_views.CategoryListView.as_view(), name="category_list"),
    # path('category/<int:pk>/', course_views.CategoryDetailView.as_view(), name="category_detail"),
    path('category/<int:pk>/', course_views.CategoryCoursesDetailView.as_view(), name="category_detail"),
    path('category/<int:pk>/update', course_views.CategoryUpdateView.as_view(), name="category_update"),
    path('category/<int:pk>/delete', course_views.CategoryDeleteView.as_view(), name="category_delete"),
    path('category/create/', course_views.CategoryCreateView.as_view(), name="category_create"),
]

education/education/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('course.urls', namespace='course')),
    path('', include('user.urls', namespace='user')),
    path('', include('about.urls', namespace='about')),
    path('api-auth/', include('rest_framework.urls')),
    path('api/v1/', include('api.urls', namespace='api')),
    path('admin/', admin.site.urls),
]

education/user/urls.py
from django.urls import path
import user.views as user_views

app_name = 'user'

urlpatterns = [
    path('teacher/', user_views.TeacherListView.as_view(), name="teacher_list"),
    path('teacher/<int:pk>/', user_views.TeacherDetailView.as_view(), name="teacher_detail"),
    path('teacher/<int:pk>/update/', user_views.TeacherUpdateView.as_view(), name="teacher_update"),
    path('teacher/<int:pk>/delete/', user_views.TeacherDeleteView.as_view(), name="teacher_delete"),
    path('teacher/create/', user_views.TeacherCreateView.as_view(), name="teacher_create"),
]

education/course/models.py
from django.db import models
from user.models import Teacher


class Category(models.Model):
    """
    Модель "Категория"
    Категория объединяет в себе курсы определенной тематики
    """
    name = models.CharField("Название", max_length=50)
    created_at = models.DateField("Дата создания", auto_now_add=True)
    updated_at = models.DateTimeField("Дата обновления", auto_now=True)

    class Meta:
        verbose_name = "Категория"
        verbose_name_plural = "Категории"

    def __str__(self):
        return self.name


class Course(models.Model):
    """
    Модель "Курс"
    Курс относится к определенной категории и включает в себя уроки (занятия)
    """
    PREPARING = 'p'
    AVAILABLE = 'a'
    STOPPED = 's'
    CLOSED = 'c'
    STATUSES = (
        (PREPARING, 'Подготавливается'),
        (AVAILABLE, 'Доступен'),
        (STOPPED, 'Приостановлен'),
        (CLOSED, 'Закрыт'),
    )

    name = models.CharField("Название", max_length=50)
    description = models.TextField("Описание")
    price = models.IntegerField("Стоимость")
    status = models.CharField("Статус", max_length=10, choices=STATUSES, default=PREPARING)
    created_at = models.DateField("Дата создания", auto_now_add=True)
    updated_at = models.DateTimeField("Дата обновления", auto_now=True)

    category = models.ForeignKey(Category, verbose_name="Категория", on_delete=models.PROTECT)
    author = models.ForeignKey(Teacher, verbose_name="Автор", on_delete=models.PROTECT,
                               limit_choices_to={'works': True}, related_name="authors")

    class Meta:
        verbose_name = "Курс"
        verbose_name_plural = "Курсы"

    def __str__(self):
        return f"{self.name} ({self.price})"


class Lesson(models.Model):
    """
    Модель "Занятие" (Урок)
    Урок относится к курсу
    """
    order_number = models.IntegerField("№", null=False)
    theme = models.CharField("Тема", max_length=50)
    description = models.TextField("Описание")
    created_at = models.DateField("Дата создания", auto_now_add=True)
    updated_at = models.DateTimeField("Дата обновления", auto_now=True)

    course = models.ForeignKey(Course, verbose_name="Курс", on_delete=models.CASCADE)

    class Meta:
        verbose_name = "Занятие"
        verbose_name_plural = "Занятия"
        ordering = "order_number",

    def __str__(self):
        return f"#{self.order_number}: {self.theme}"

education/course/views.py
from django.db.models import Q
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import DetailView, ListView, CreateView, UpdateView, DeleteView

from user.models import Teacher
from .models import Course, Category

app_name = "course"


class PageTitleMixin:
    """
    Добавляет возможность задать заголовок страницы

    page_title: заголовок страницы
    """
    page_title = ''

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['page_title'] = self.page_title
        return context


class CourseListView(PageTitleMixin, ListView):
    model = Course
    page_title = 'Список курсов'
    queryset = model.objects.filter(Q(status=Course.AVAILABLE) | Q(status=Course.PREPARING))


class CourseDetailView(DetailView):
    model = Course


class CourseCreateView(PageTitleMixin, CreateView):
    model = Course
    success_url = reverse_lazy('course:course_list')
    fields = '__all__'
    page_title = 'Создание курса'


class CourseUpdateView(PageTitleMixin, UpdateView):
    model = Course
    fields = '__all__'
    page_title = 'Редактирование курса'

    def get_success_url(self):
        return reverse_lazy('course:course_detail', kwargs={'pk': self.object.pk})


class CourseDeleteView(DeleteView):
    model = Course
    success_url = reverse_lazy('course:course_list')


class CategoryListView(PageTitleMixin, ListView):
    model = Category
    page_title = "Список категорий"


class CategoryDetailView(DetailView):
    model = Category


class CategoryCoursesDetailView(DetailView):
    model = Category

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['courses'] = Course.objects.filter(category=self.kwargs['pk'])
        return context


class CategoryCreateView(PageTitleMixin, CreateView):
    model = Category
    success_url = reverse_lazy('course:category_list')
    fields = '__all__'
    page_title = 'Добавление категории'


class CategoryUpdateView(PageTitleMixin, UpdateView):
    model = Category
    fields = '__all__'
    page_title = 'Редактирование категории'

    def get_success_url(self):
        return reverse_lazy('course:category_detail', kwargs={'pk': self.object.pk})


class CategoryDeleteView(DeleteView):
    model = Category
    success_url = reverse_lazy('course:category_list')


def index(request):
    teachers = Teacher.objects.all()[:10]
    categories = Category.objects.all()[:10]
    courses = Course.objects.all()[:10]

    context = {
        'page_title': 'Главная страница',
        'teachers': teachers,
        'categories': categories,
        'courses': courses,
    }
    return render(request, 'course/index.html', context)

education/course/templates/course/base.html
<!doctype html>
<html lang="en">
<head>
    {% load static %}

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
{#    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">#}
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">

    <title>{% block title %}
        Title
    {% endblock %}</title>
</head>
<body>
{% block menu %}
    <nav class="navbar navbar-expand-md navbar-light" style="background-color: #f7f7f7;">
        <div class="container-fluid">
            <a class="navbar-brand" href="{% url 'course:index' %}">Инструкция</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false"
                    aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
                <div class="navbar-nav">
                    <a class="nav-link active" href="{% url "user:teacher_list" %}">Преподаватели</a>
                </div>
                <div class="navbar-nav">
                    <a class="nav-link active" href="{% url "course:category_list" %}">Категории</a>
                </div>
                <div class="navbar-nav">
                    <a class="nav-link active" href="{% url "course:course_list" %}">Курсы</a>
                </div>
                <div class="navbar-nav">
                    <a class="nav-link active" href="{% url "about:about" %}">Контакты</a>
                </div>
            </div>
        </div>
    </nav>
{% endblock %}

<div class="container pt-3">
    {% block container %}

    {% endblock %}
</div>

{% block footer %}

{% endblock %}


<script src="{%  static 'js/bootstrap.bundle.min.js' %}"></script>
<!-- Optional JavaScript; choose one of the two! -->

<!-- Option 1: Bootstrap Bundle with Popper -->
{#    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>#}

<!-- Option 2: Separate Popper and Bootstrap JS -->
<!--
<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.5.4/dist/umd/popper.min.js" integrity="sha384-q2kxQ16AaE6UbzuKqyBE9/u/KzioAlnx2maXQHiDX9d4/zp8Ok3f+M7DPm+Ib6IU" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.min.js" integrity="sha384-pQQkAEnwaBkjpqZ8RU1fF1AKtTcHJwFl3pblpTlHXybJjHpMYo79HY3hIi4NKxyj" crossorigin="anonymous"></script>
-->
</body>
</html>

education/course/templates/course/category_confirm_delete.html
{% extends 'course/base.html' %}

{% block title %}
    {{ object.name }}
{% endblock %}

{% block container %}
    <form method="post">{% csrf_token %}
        <p>Вы точно хотите удалить категорию "{{ object.name }}"?</p>
        <input class="btn btn-danger" type="submit" value="Да, удалить">
        <a href="{% url 'course:category_list' %}" class="btn btn-success">Отмена</a>
    </form>
{% endblock %}

education/course/templates/course/category_detail.html
{% extends 'course/base.html' %}

{% block title %}
    {{ category.name }}
{% endblock %}

{% block container %}
    <h3>{{ category.name }}</h3>
    <p><small class="text-muted">Дата изменения: {{ category.updated_at }}</small></p>
    {% if courses %}
        <h5>Курсы по выбранной категории</h5>
        <ul>
            {% for course in courses %}
                <li>
                    <a href="{% url 'course:course_detail' pk=course.pk %}">{{ course.name }}</a>
                </li>
            {% endfor %}
        </ul>
    {% endif %}
    <div class="btn-group btn-group-sm" role="group">
        <a href="{% url 'course:category_update' pk=category.pk %}"
           class="btn btn-warning">Редактировать</a>
        <a href="{% url 'course:category_delete' pk=category.pk %}"
           class="btn btn-danger">Удалить</a>
    </div>
    <p><a href="{% url 'course:category_list' %}">К списку категорий</a></p>
{% endblock %}

education/course/templates/course/category_form.html
{% extends 'course/base.html' %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input class="btn btn-success" type="submit" value="Сохранить">
    </form>
{% endblock %}

education/course/templates/course/category_list.html
{% extends "course/base.html" %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <h3>Список категорий</h3>
    <ul>
        {% for category in object_list %}
            <li>
                <a href="{% url 'course:category_detail' pk=category.pk %}">{{ category.name }}</a>
            </li>
        {% empty %}
            <p>Нет данных для отображения</p>
        {% endfor %}
    </ul>
    <p><a href="{% url 'course:category_create' %}" class="btn btn-success">Добавить категорию</a></p>
{% endblock %}

education/course/templates/course/category_update_form.html
{% extends 'course/base.html' %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input class="btn btn-success" type="submit" value="Сохранить">
    </form>
{% endblock %}

education/course/templates/course/course_confirm_delete.html
{% extends 'course/base.html' %}

{% block title %}
    {{ object.name }}
{% endblock %}

{% block container %}
    <form method="post">{% csrf_token %}
        <p>Вы точно хотите удалить курс "{{ object.name }}"?</p>
        <input class="btn btn-danger" type="submit" value="Да, удалить">
    </form>
{% endblock %}

education/course/templates/course/course_detail.html
{% extends 'course/base.html' %}

{% block title %}
    {{ course.name }}
{% endblock %}

{% block container %}
    <h3>{{ course.name }}</h3>
    <p><small class="text-muted">Категория: {{ course.category|lower }}</small></p>
    <p><b>Описание:</b> {{ course.description }}</p>
    <p><b>Статус:</b> {{ course.get_status_display }}</p>
    <p><b>Стоимость:</b> {{ course.price }} руб.</p>
    <p><b>Автор:</b> {{ course.author }}</p>
    <div class="btn-group btn-group-sm">
        <a href="{% url 'course:course_update' pk=course.pk %}"
           class="btn btn-warning">Редактировать</a>
        <a href="{% url 'course:course_delete' pk=course.pk %}"
           class="btn btn-danger">Удалить</a>
    </div>
    <p><a href="{% url 'course:course_list' %}">К списку курсов</a></p>
{% endblock %}

education/course/templates/course/course_form.html
{% extends 'course/base.html' %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input class="btn btn-success" type="submit" value="Сохранить">
    </form>
{% endblock %}

education/course/templates/course/course_list.html
{% extends "course/base.html" %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <h3>Список курсов</h3>
    <ul>
        {% for course in object_list %}
            <li>
                <a href="{% url 'course:course_detail' pk=course.pk %}">{{ course.name }}</a>
            </li>
        {% empty %}
            <p>Нет данных для отображения</p>
        {% endfor %}
    </ul>
    <p><a href="{% url 'course:course_create' %}" class="btn btn-success">Создать новый курс</a></p>
{% endblock %}

education/course/templates/course/course_update_form.html
{% extends 'course/base.html' %}

{% block title %}
    {{ page_title }}
{% endblock %}

{% block container %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input class="btn btn-success" type="submit" value="Сохранить">
    </form>
{% endblock %}

education/course/templates/course/index.html
{% extends 'course/base.html' %}

{% block title %}
    Инструкция
{% endblock %}

{% block container %}
    <h3>Порядок использования</h3>
    <ol>
        <li><a href="{% url 'user:teacher_create' %}">Создать преподавателя</a></li>
        <li><a href="{% url 'course:category_create' %}">Создать категорию</a></li>
        <li><a href="{% url 'course:course_create' %}">Создать курс</a></li>
    </ol>

    <div class="row">
        <div class="col-sm">
            <h4>Список преподавателей</h4>
            <ul class="list-group">
                {% for teacher in teachers %}
                    <li class="list-group-item d-flex justify-content-between align-items-center">
                        <a href="{% url 'user:teacher_detail' pk=teacher.pk %}">{{ teacher.full_name }}</a>
                        <div class="btn-group" role="group">
                            <a href="{% url 'user:teacher_update' pk=teacher.pk %}"
                               class="btn btn-warning btn-sm" role="button">Редактировать</a>
                            <a href="{% url 'user:teacher_delete' pk=teacher.pk %}"
                               class="btn btn-danger btn-sm" role="button">Удалить</a>
                        </div>
                    </li>
                {% empty %}
                    <p>Нет данных для отображения</p>
                {% endfor %}
            </ul>
        </div>
        <div class="col-sm">
            <h4>Список категорий</h4>
            <ul class="list-group">
                {% for category in categories %}
                    <li class="list-group-item d-flex justify-content-between align-items-center">
                        <a href="{% url 'course:category_detail' pk=category.pk %}">{{ category.name }}</a>
                        <div class="btn-group" role="group">
                            <a href="{% url 'course:category_update' pk=category.pk %}"
                               class="btn btn-warning btn-sm" role="button">Редактировать</a>
                            <a href="{% url 'course:category_delete' pk=category.pk %}"
                               class="btn btn-danger btn-sm" role="button">Удалить</a>
                        </div>
                    </li>
                {% empty %}
                    <p>Нет данных для отображения</p>
                {% endfor %}
            </ul>
        </div>
        <div class="col-sm">
            <h4>Список курсов</h4>
            <ul class="list-group">
                {% for course in courses %}
                    <li class="list-group-item d-flex justify-content-between align-items-center">
                        <a href="{% url 'course:course_detail' pk=course.pk %}">{{ course.name }}</a>
                        <div class="btn-group" role="group">
                            <a href="{% url 'course:course_update' pk=course.pk %}"
                               class="btn btn-warning btn-sm" role="button">Редактировать</a>
                            <a href="{% url 'course:course_delete' pk=course.pk %}"
                               class="btn btn-danger btn-sm" role="button">Удалить</a>
                        </div>
                    </li>
                {% empty %}
                    <p>Нет данных для отображения</p>
                {% endfor %}
            </ul>
        </div>
    </div>
{% endblock %}